/*
 * Copyright (c) 1999 Greg Haerr <greg@censoft.com>
 *
 * Null Linear Video Driver for MicroWindows
 *
 * Inspired from Ben Pfaff's BOGL <pfaffben@debian.org>
 */
#include "../device.h"
#include "fb.h"

static int
null_init(void)
{
	return 0;
}

static void
null_drawpixel(FARADDR addr, COORD x, COORD y, PIXELVAL c)
{
}

static PIXELVAL
null_readpixel(FARADDR addr, COORD x, COORD y)
{
	return 0;
}

static void 	
null_drawhorzline(FARADDR addr, COORD x1, COORD x2, COORD y, PIXELVAL c)
{
}

static void	
null_drawvertline(FARADDR addr, COORD x, COORD y1, COORD y2, PIXELVAL c)
{
}

static void	
null_blit(FARADDR dstaddr, COORD destx, COORD desty, COORD w, COORD h,
	FARADDR srcaddr, COORD srcx, COORD srcy)
{
}

FBENTRY fbnull = {
	null_init,
	null_drawpixel,
	null_readpixel,
	null_drawhorzline,
	null_drawvertline,
	null_blit
};
